'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _theme = require('../../utils/theme');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var StyledButton = (0, _styledComponents2.default)('button').withConfig({
  displayName: 'Button__StyledButton'
})(['height:36px;min-width:90px;padding:0 12px;border:0;outline:none;box-shadow:', ';background:', ';color:', ';font-size:', ';text-transform:uppercase;cursor:', ';&:hover{transition:color .3s ease;background:', ';color:', ';}'], function (props) {
  return props.styled.selected ? props.theme.boxShadow.selected : props.theme.boxShadow.light;
}, (0, _theme.fromAtoms)('Button', 'styled.type', 'background'), (0, _theme.fromAtoms)('Button', 'styled.type', 'color'), function (props) {
  return props.theme.fontSizes.normal;
}, function (props) {
  return props.disabled ? 'not-allowed' : 'pointer';
}, (0, _theme.fromAtoms)('Button', 'styled.type', 'hoverBackground'), (0, _theme.fromAtoms)('Button', 'styled.type', 'hoverColor'));

/**
 * A button that will run a callback on click
 * ```javascript
 *  <Button onClick={alert} text="Submit" />
 * ```
 */

var Button = function (_React$PureComponent) {
  _inherits(Button, _React$PureComponent);

  function Button(props, context) {
    _classCallCheck(this, Button);

    var _this = _possibleConstructorReturn(this, (Button.__proto__ || Object.getPrototypeOf(Button)).call(this, props, context));

    _this.handleClick = _this.handleClick.bind(_this);
    return _this;
  }

  _createClass(Button, [{
    key: 'handleClick',
    value: function handleClick(e) {
      var _props = this.props,
          onClick = _props.onClick,
          disabled = _props.disabled,
          text = _props.text;


      if (onClick && !disabled) {
        onClick(e, text);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props2 = this.props,
          children = _props2.children,
          text = _props2.text,
          type = _props2.type,
          primary = _props2.primary,
          disabled = _props2.disabled,
          danger = _props2.danger,
          selected = _props2.selected,
          style = _props2.style,
          className = _props2.className;


      return _react2.default.createElement(
        StyledButton,
        {
          disabled: disabled,
          onClick: this.handleClick,
          type: type,
          styled: {
            selected: selected,
            type: disabled && 'disabled' || primary && 'primary' || danger && 'danger' || 'default'
          },
          style: style,
          className: className
        },
        children || text
      );
    }
  }]);

  return Button;
}(_react2.default.PureComponent);

Button.propTypes = {
  /**
  * Callback that will be run when the button is clicked.
  */
  onClick: _propTypes2.default.func,
  /**
  * Text that will be used as the button label.
  * If this props is provided, it will be passed back to the `onClick` handler
  */
  text: _propTypes2.default.string,
  /**
  * Disable the button.
  */
  disabled: _propTypes2.default.bool,
  /**
   * Render the button in $turquoise (useful for CTAs)
   */
  primary: _propTypes2.default.bool,
  /**
   * Add styling to show the button as selected
   */
  selected: _propTypes2.default.bool,
  /**
   * Turn the button red to indicate something bad might happen
   */
  danger: _propTypes2.default.bool,
  /**
   * The type of button, as it relates to <form> components
   */
  type: _propTypes2.default.string
};

Button.defaultProps = {
  text: 'Submit'
};

exports.default = Button;