'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Button = require('../Button');

var _Button2 = _interopRequireDefault(_Button);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * A dialog window
 * ```javascript
 * export defaut function DialogExample({closeHandler, actionClickHandler}) {
 *  return (
 *   <Dialog
 *      active={true}
 *      actions={['Submit', 'Cancel']}
 *      onClose={closeHandler}
 *      onActionClick={actionClickHandler}
 *    >
 *      <p>Here is some content that I would like to display</p>
 *    </Dialog>
 *  );
 * }
 * ```
 *
 * Example with pre-created action elements
 * ```javascript
 * export defaut function DialogExample({someHandlerFunc, otherHandlerFunc, handleClose}) {
 *     const Action1 = () => (
 *      <div onClick={someHandlerFunc}>Action1</div>
 *    );
 *     const Action2 = () => (
 *       <div onClick={otherHandlerFunc}>Action2</div>
 *    );
 *
 *    return (
 *      <Dialog
 *         active={true}
 *         actions={[Action1, Action2]}
 *         onClose={handleClose}
 *       >
 *         <p>This one has custom actions</p>
 *       </Dialog>
 *    );
 * }
 * ```
 */

var Dialog = function (_React$Component) {
  _inherits(Dialog, _React$Component);

  function Dialog(props, context) {
    _classCallCheck(this, Dialog);

    var _this = _possibleConstructorReturn(this, (Dialog.__proto__ || Object.getPrototypeOf(Dialog)).call(this, props, context));

    _this.handleActionClick = _this.handleActionClick.bind(_this);
    _this.handleClose = _this.handleClose.bind(_this);
    return _this;
  }

  _createClass(Dialog, [{
    key: 'handleActionClick',
    value: function handleActionClick(text) {
      this.props.onActionClick(text);
    }
  }, {
    key: 'handleClose',
    value: function handleClose() {
      this.props.onClose();
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          children = _props.children,
          active = _props.active,
          actions = _props.actions,
          overlay = _props.overlay;

      return _react2.default.createElement(
        'div',
        { className: active ? 'weave-dialog active' : 'weave-dialog' },
        _react2.default.createElement(
          'div',
          { className: 'weave-dialog-window' },
          _react2.default.createElement(
            'div',
            { className: 'weave-dialog-close' },
            _react2.default.createElement('span', { onClick: this.handleClose, className: 'fa fa-close' })
          ),
          _react2.default.createElement(
            'div',
            { className: 'weave-dialog-content' },
            children
          ),
          _react2.default.createElement(
            'div',
            { className: 'weave-dialog-actions' },
            actions && actions.map(function (Action, i) {
              if (_react2.default.isValidElement(Action)) {
                return _react2.default.cloneElement(Action, { key: i });
              }
              return _react2.default.createElement(_Button2.default, { key: i, onClick: function onClick() {
                  return _this2.handleActionClick(Action);
                }, text: Action });
            })
          )
        ),
        _react2.default.createElement('div', {
          onClick: this.handleClose,
          className: overlay ? 'weave-dialog-overlay overlay-active' : 'disabled' })
      );
    }
  }]);

  return Dialog;
}(_react2.default.Component);

Dialog.propTypes = {
  /**
   * Flag to show/hide the dialog
   */
  active: _propTypes2.default.bool,
  /**
   * An array of options that the user will be able to click.
   * Each item in the array will be rendered as a <Button /> in the dialog window.
   * Items can also be React elements.
   */
  actions: _propTypes2.default.array,
  /**
   * Callback that will be run when the dialog is closed
   */
  onClose: _propTypes2.default.func,
  /**
   * Callback that runs when an action is clicked by the user. If the actions
   * If the `actions` prop is an array of strings,
   * this callback will return the action that was clicked.
   */
  onActionClick: _propTypes2.default.func,
  /**
   * Toggles a modal overlay. If set to true, the overlay will appear,
   */
  overlay: _propTypes2.default.bool
};

Dialog.defaultProps = {
  overlay: true
};

exports.default = Dialog;